require "defines"

onbuild = function (event) 
	if event.createdentity.type == "locomotive" or event.createdentity.type == "cargo-wagon" and event.createdentity.train ~= nil then
		glob.trains = addtraintotable(glob.trains, event.createdentity.train)
	-- elseif event.createdentity.type == "rail-signal" then
		-- game.players[1].print("lwx: " .. glob.trains[1].lastWagon.position.x .. " lwy: " .. glob.trains[1].lastWagon.position.y .. " lwo: " .. glob.trains[1].lastWagon.orientation)
		-- game.players[1].print("d: " .. event.createdentity.direction .. " x: " .. event.createdentity.position.x .. " Y: " .. event.createdentity.position.y)
	end
end

ontickklazy = function(event)
	if event.tick %60 == 3 then
		if glob.trains ~= nil then
			game.onevent(defines.events.ontick, ontickmain)
		end
	end
end

ontickmain = function (event)
	if glob.trains == nil then
		game.onevent(defines.events.ontick, ontickklazy)
		return
	end
	
	if event.tick %15 == 9 then
		cleantraintable(glob.trains)
		--game.players[1].print(event.tick)
		lasti = 0
		for i,trainInfo in ipairs(glob.trains) do
			lasti = i
			train = trainInfo.train
			trainInfo = updateinfo(trainInfo,train)
			if isvalid(train) then
				if trainInfo.enabled then
					if trainInfo.lastWagonReversed ~= nil and trainInfo.lastWagon.orientation % 0.125 < 0.001 then
						--game.players[1].print(trainInfo.lastWagon.orientation)
						--if trainInfo.train.speed > 0.01 then game.players[1].print("moving forward" ) end
						signalinfo = getsignalpositionanddirection(trainInfo)
						if signalinfo ~= nil then
							if game.canplaceentity({name="moving-block-rail-signal",position=signalinfo.position} )then
								--game.players[1].print("x: " .. signalinfo.position[1] .. " y: " .. signalinfo.position[2])
								game.createentity({name = "moving-block-rail-signal", position = signalinfo.position, direction = signalinfo.direction, force = game.forces.player})
								
								tempEntities = game.findentitiesfiltered{area = {signalinfo.position, signalinfo.position}, name= "moving-block-rail-signal"} -- gets all resources in the rectangle
								if isvalid(tempEntities[1]) and tempEntities[1].name == "moving-block-rail-signal" then
									-- trainInfo.signal.destroy()
									-- trainInfo.signal = nil
									if trainInfo.signal ~= nil then
										if tempEntities[1].signalstate > 0 then
											--game.players[1].print("New")
											trainInfo.signal.destroy()
											trainInfo.signal = tempEntities[1]
										else
											tempEntities[1].destroy() 
										end
									else 
										trainInfo.signal = tempEntities[1]
									end
									
									--game.players[1].print(trainInfo.signal.signalstate)
								end
							end
						-- elseif isvalid(trainInfo.signal) and trainInfo.train.speed > 0.01 then
							-- tempEntities = game.findentitiesfiltered{area = {{trainInfo.signal.position.x - 0.5, trainInfo.signal.position.y - 0.5}, {trainInfo.signal.position.x + 0.5, trainInfo.signal.position.y + 0.5}}, type= "rail-signal"} -- gets all resources in the rectangle
							-- if tempEntities ~= nil and isvalid(tempEntities[1]) and not tempEntities[1].equals(trainInfo.signal) then
								-- --game.players[1].print("BANG")
								-- trainInfo.signal.destroy()
								-- trainInfo.signal = nil
							-- end
						end
					end
				end
				--game.players[1].print("speed: " .. trainInfo.train.speed)
				--game.players[1].print("direction: " .. trainInfo.locomotive.direction)
				--game.players[1].print("orientation: " .. trainInfo.locomotive.orientation)
				-- signalinfo = getsignalpositionanddirection(trainInfo.train)
				-- position = signalinfo.position
				-- if trainInfo.signal ~= nil and traininfo.signal.valid then
					-- if trainInfo.signal.position.x ~= signalinfo.position.x or trainInfo.signal.position.y ~= signalinfo.position.y then
						-- trainInfo.signal.destroy()
						-- trainInfo.singal = nil
					-- end
					-- game.createentity("rail-signal", signalinfo.position, signalinfo.direction)
				-- end
			elseif isvalid(trainInfo.locomotive) or isvalid(trainInfo.wagon) then
				
			end
		end
		if lasti == 0 then
			glob.trains = nil
		end
		--game.players[1].print(lasti)
	end
end

ontrainchangedstate = function (event)
	glob.trains = addtraintotable(glob.trains,event.train)
end

-- function destroynexttick(entity)
	-- if glob.destroy = nil then
		-- glob.destroy = {}
	-- end
	-- table.insert(glob.destroy,entity)
-- end

-- Default Subscriptions
game.onevent(defines.events.onbuiltentity, onbuild)
game.onevent(defines.events.ontick, ontickklazy)
game.onevent(defines.events.ontrainchangedstate, ontrainchangedstate)

function getsignalpositionanddirection(trainInfo)
	train = trainInfo.train
	orientation = trainInfo.lastWagon.orientation
	if trainInfo.lastWagonReversed then
		orientation = (trainInfo.lastWagon.orientation + 0.5) % 1
	end
	lwp = trainInfo.lastWagon.position
	if orientation == 0 then
		return {position = {lwp.x + 1.5, math.floor(lwp.y) + 3.5}, direction = 4}
	elseif orientation == 0.5 then
		return {position = {lwp.x - 1.5, math.floor(lwp.y) - 3.5}, direction = 0}
	elseif orientation == 0.75 then
		return {position = {math.floor(lwp.x) + 4.5, lwp.y - 1.5}, direction = 2}
	elseif orientation == 0.25 then
		return {position = {math.floor(lwp.x) - 4.5, lwp.y + 1.5}, direction = 6}
	elseif orientation == 0.875 then
		return {position = {math.floor(lwp.x) + 4.5, math.floor(lwp.y) + 2.5}, direction = 3}
	elseif orientation == 0.375 then
		return {position = {math.floor(lwp.x) - 4.5, math.floor(lwp.y) - 2.5}, direction = 7}
	elseif orientation == 0.625 then
		return {position = {math.floor(lwp.x) + 2.5, math.floor(lwp.y) - 3.5}, direction = 1}
	elseif orientation == 0.125 then
		return {position = {round(lwp.x) - 1.5, round(lwp.y,0) + 3.5}, direction = 5}
	end
	return nil
	
end

function rotatePoint(position, rotation)
	--debugLog("POSITION X: " .. position.x .. " Y: " .. position.y)
	--debugLog("ROTATION: " .. rotation)
	local radians = ((rotation * 2) - 1) * math.pi
	--debugLog("RADIANS: " .. radians)
	local cosr = math.cos(radians)
	local sinr = math.sin(radians)
	
	local newPosition = {x = (position.x * cosr) - (position.y * sinr), y = (position.y * cosr) + (position.x * sinr)}
	--position.x = math.cos(radians) * position.x
	--position.y = math.sin(radians) * position.y
	return newPosition
end

function cleantraintable(trains)
	if trains ~= nil then
		removeTable = {}
		for i,trainInfo in ipairs(trains) do
			if not isvalid(trainInfo.train) and not trainInfo.locomotive.valid then
				if isvalid(trainInfo.signal) then
					trainInfo.signal.destroy()
					trainInfo.signal = nil
				end
				table.insert(removeTable, i)
				--table.remove(trains, i)
			elseif not trainInfo.train.valid then
				trainInfo.train = trainInfo.locomotive.train
			end
		end
		for i, rm in ipairs(removeTable) do
			table.remove(trains, rm - i + 1)
		end
	end
end

function getfirstlocomotive(train)
	if isvalid(train) then
		for i,wagon in ipairs(train.carriages) do
			if wagon.type == "locomotive" then
				return wagon
			end
		end
	end
end

function getlastwagon(train)
	lastWagon  = nil
	for i,wagon in ipairs(train.carriages) do
		--game.players[1].print(wagon.position.x .. " .. " .. wagon.position.y)
		lastWagon = wagon
	end
	--game.players[1].print(lastWagon.position.x .. " .. " .. lastWagon.position.y)
	return lastWagon
end

function addtraintotable(trains,train)
	if trains == nil then
		trains = {}
	end
	trainInfo = gettrainfromtable(trains,train)
	if trainInfo == nil and train ~= nil then
		if train.locomotives.backmovers[1] == nil then
			locomotive = getfirstlocomotive(train)
			wagon = getlastwagon(train)
			if locomotive ~= nil then 
				--game.players[1].print("insert traiN!")
				table.insert(trains, updateinfo({}, train))
			end
		end
	else
		updatetraininfo(trains,train)
	end
	return trains
end

function updatetraininfo(trains,train)
	for i, trainInfo in ipairs(trains) do
		if trainequals(trainInfo.train,train) then
			trains[i] = updateinfo(trainInfo,train)
		end		
	end
end

function updateinfo(trainInfo, train)
	if isvalid(train) then
		trainInfo.train = train
		tempLocomotive = getfirstlocomotive(train)
		if tempLocomotive.equals(trainInfo.locomotive) then
			trainInfo.enabled = arelocomotivesallfacingthesameway(train)
		end
		trainInfo.locomotive = tempLocomotive
		tempLastWagon = getlastwagon(train)
		if trainInfo.lastWagon == nil or not trainInfo.lastWagon.equals(tempLastWagon) or trainInfo.lastWagonReversed == nil then
			trainInfo.lastWagon  = tempLastWagon
			reversed = islastwagonreversed(trainInfo)
			--if reversed ~= nil then
				trainInfo.lastWagonReversed = reversed
			--end
		end
		
		-- if trainInfo.lastWagonReversed ~= nil and trainInfo.lastWagonReversed then
			-- game.players[1].print("Back")
		-- elseif trainInfo.lastWagonReversed == nil then
			-- game.players[1].print("NIL")
		-- else
			-- game.players[1].print("forward")
		-- end
		return trainInfo
	end
	return nil
end

function islastwagonreversed(trainInfo)
	tempVal = trainInfo.locomotive.orientation - trainInfo.lastWagon.orientation
	if trainInfo.locomotive.orientation < trainInfo.lastWagon.orientation then
		tempVal = trainInfo.lastWagon.orientation - trainInfo.locomotive.orientation
	end
	--game.players[1].print("F: " .. trainInfo.locomotive.orientation .. " B: " .. trainInfo.lastWagon.orientation .. " D: " .. tempVal)
	if tempVal > 0.15 and tempVal < 0.5 then
		--game.players[1].print("UNSURE")
		return nil
	end
	if tempVal >= 0.5 then
		--game.players[1].print("REVERSED")
		return true
	end
	return false
end

function arelocomotivesallfacingthesameway(train)
	firstDirection = nil
	for i,wagon in ipairs(train.carriages) do
		if isvalid(wagon) and wagon.type == "locomotive" then
			if firstDirection == nil then
				--game.players[1].print(wagon.orientation .. ", " .. wagon.direction)
				firstDirection = wagon.orientation
			end
			
			if firstDirection > wagon.orientation then 
				tempVal = firstDirection - wagon.orientation
			else
				tempVal = wagon.orientation - firstDirection
			end
			
			--game.players[1].print("f: " .. firstDirection .. " b: " .. wagon.orientation .. " maths: " .. tempVal)
			if tempVal >= 0.5 then
				--game.players[1].print("DISABLE!")
				return false
			end
		end
	end
	return true
end

function intraintable(trains, train)
	tempTrain = getrainfromtable(trains,train)
	if tempTrain ~= nil then
		return true
	end
	return false
end

function gettrainfromtable(trains,train)
	for i,trainInfo in ipairs(trains) do
		if not isvalid(trainInfo.train) then trainInfo.train = trainInfo.locomotive.train end
		
		if trainequals(trainInfo.train,train) then
			return trainInfo
		end
	end
end

function trainequals(trainA,trainB)
	if isvalid(trainA) and isvalid(trainB) then
		if trainB.carriages[1].equals(trainA.carriages[1]) then
			return true
		end
	end
	return false
end

function isvalid(entity)
	if entity ~= nil and entity.valid then
		return true
	end
	return false
end

function getn (t)
  if type(t.n) == "number" then return t.n end
  local max = 0
  for i, _ in ipairs(t) do
    if type(i) == "number" and i>max then max=i end
  end
  return max
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

